%% Seminář 4
%% Programování I
%% 
% * program flow (cykly, větvení)
% * vstup a výstup
% Konstrukce |if|, |elseif|, |else|
% *syntaxe:*
% 
% |if podminka|
% 
% |kod 1|
% 
% |elseif|
% 
% |kod 2|
% 
% |else|
% 
% |kod 3|
% 
% |end|
% 
% Alternativní větve je možné vynechat.
% 
% _Jak by vypadalo hlednání nejmenšího ze tří čísel?_

a = 6
b = -6
c = -4

if a <= b && a <= c
  minimum = a
elseif b <= c
  minimum = b
else
  minimum = c
end
%% 
% Rozdíl mezi | a ||: | se aplikuje na každý prvek matice, || na skalár 
% 
% U & a && platí to samé
% Konstrukce |switch|
% *syntaxe:*
% 
% |switch vyraz|
% 
% case a1|
% 
% |kod 1|
% 
% |...|
% 
% |otherwise|
% 
% |kod n|
% 
% |end|
% 
% _Vytvořte proměnnou n, která nabývá hodnot 1, 2 nebo 3. Podle toho jakou má 
% hodnotu vypište jedna, dva nebo tři._

n = 1
switch n
    case 1
        disp('jedna');
    case 2
        disp('dva');
    otherwise
        disp('tri');        
end
% Cyklus |while|
% *syntaxe:*
% 
% |while podminka|
% 
% |kod|
% 
% |end|
% 
% _Pomocí cyklu |while| vypočítejte pro zadané |n| n!._

n = 4
f = n

% factorial(n)

while n > 1
    n = n - 1;
    f = f * n;
end

disp(['n! = ' num2str(f)]);
% Cyklus |for|
% *syntaxe:*
% 
% |for promenna = vektor_hodnot|
% 
% |kod|
% 
% |end|
% 
% *Vektory*: |[1 2 3]|, |1 : 3|, |1 : 2 : 3|
% 
% _Pro vektor |x| obsahující 100 náhodných celých čísel od 0 do 500 (pro vytvoření 
% použijte funkci |randi()|), spočítejte vektor |y| tak, že bude obsahovat druhé 
% mocnicny prvků vektoru |x|._ 

x = randi(500,[1,100]);
%y = zeros(1,100);

tic();
for i = 1 : 100
    y(i) = x(i)*x(i);
end
toc()
%% 
% Obalte for cyklus funkcemi |tic()| a |toc()| pro zobrazení doby běhu výpočtu.
%% 
% _Spočítejte vektor |y2| z vektoru |x| pomocí maticových operací a zobrazte 
% dobu běhu výpočtu._

tic();
y2 = x .* x;
toc()
% Break a continue
% Stejně jako v jiných jazycích i v Matlabu existují příkazy |break| a |continue|.
% 
% Jaký bude výstup následujících dvou kódů?

% break
vystup = [];
for i = 1 : 10
    if mod(i,3) == 0
        break
    end
    vystup = [vystup i];
end
display(vystup);

% continue
vystup = [];
for i = 1 : 10
    if mod(i,3) == 0
        continue
    end
    vystup = [vystup i];
end
display(vystup);
%% Vstup a výstup
% Výstup
% Na obrazovku
% *Funkce*: |disp()|, |display(), fprintf()|
% 
% |fprintf(format, ...) --| syntaxe shodná jako printf v C. 
% 
% _Vytvořte proměnnou a, přiřaďte jí hodnotu 100 a na obrazovku vypište text 
% |"Promenna a ma hodnotu 10"|._

a = 10;
fprintf('Promenna a ma hodnotu %i', a);
% Do souboru
% *Funkce*:  writematrix|(),| nízkoúrovňově: |fprintf()|, |fwrite()|, ...
% 
% |writematrix(M, cesta_k_souboru)| můžeme využít k uložení matice M do souboru. 
% 
% |fprintf(soubor, format, ...)| můžeme nastavit, že se nebude vypisovat na 
% obrazovku, ale do souboru tím, že jako první argument specifikujeme soubor, 
% který  otevřeme pomocí příkazu |fopen(cesta,rezim).|
% 
% _Vytvořte náhodnou matici |M| (libovolné velikosti) a uložte jí do souboru 
% |matice1.txt (matice2.txt)| pomocí |writematrix()| i pomocí |fprintf()._|

M = randi(10,[5,5]);
writematrix(M,'matice1.txt');

fid = fopen("matice2.txt",'w');
fprintf(fid, "%i %i %i %i %i \n" ,M);
% Vstup
% UI prvky
% O UI prvcích jsme mluvili dříve.
% 
% _Vytvořte proměnnou a. Na ní navažte checkbox. Pokud je checkbox zaškrtnutý, 
% vypište "Ano", jinak vypište "Ne"._

a = false
if a
    disp('Ano');
else
    disp('Ne');
end
% Vstup z klávesnice
% *Funkce*: |input()|
% 
% |nactena_hodnota = input(text)|

% nacteni cisla
cislo = input('Vložte číslo: ');
disp(cislo);
%% 
% _Zkuste při zadávání vstupu z klávesnice napsat |15 + 15|. Co se uloží do 
% proměnné |cislo|?_
%% 
% Pokud nechceme, aby se výraz vyhodnotil, použijeme jako druhý argument funkce 
% |input()| |'s'|. 
% 
% _Vyzkoušejte._

cislo = input('Vložte číslo: ', 's');
disp(cislo);
% Grafický dialog
% *Funkce*: |menu()|
% 
% |menu(hlavicka, volba1, volba2, ...)|
% 
% Funkce vrací index vybrané položky.

volba = menu('Vyberte barvu', "cervena", "zelena", "modra");
disp(volba);
%% 
% Volby lze zadat i jako matici řetězců. 
%% 
% _Upravte předchozí sekci tak, aby se vypsal řetěžec, který uživatel zvolil._

moznosti = ["cervena" "zelena" "modra"];
volba = menu('Vyberte barvu', moznosti);
disp(moznosti(volba));
% Vstup ze souboru
% *Funkce*: load(), nízkoúrovňově: |fread()|, |fget()|, ...
% 
% _Načtete matici uloženou v souboru |matice1.txt._|

Mat = load("matice1.txt");
Mat